/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
FVRING_TECHNICAL_TESTS
V.Final
jan/2004
http://www.fvring.com
-----------------------------------------------------------------------------
Autor : 				Fonzie Voltonov
Dev. from :				Modified from Paul Lee DEMOS
Lib. from :				Modified from KANEDA lib.
-----------------------------------------------------------------------------
Working on real hardware :	yes
Source code complete :		yes
Demo finished :			yes
Include needed :			possible fvrlib.h (just for some symbol def.)
-----------------------------------------------------------------------------
Notes: 
-This code is a linear demo(so not very interesting) witch show
some parts of the VDP abilities.
Beginners notes:
-The variables witch are defined out of the main() are static (on ROM).
This is due to a SGCC bug, sorry.
Real hardware notes:
-You need to fix header(rom lenght) to get a
working rom on real hardware.
-The horizontal scroll line/line and cell/cell
cause some tiles blink around the screen.

$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

#include "fvrlib.h"

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Function prototypes.
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

extern ulong sega[];
extern ulong sprites[];
extern ulong bg_md[];
extern ulong pal[];
extern ulong chor[];
extern uchar fvr_joypad_result[];

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Variables/Fonctions externes && globales.
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

/*sega pal*/


uint pal_gray[16]={0x888,0xFFF,0x666,0x888,0xAAA,0x000,0x222,0xDDD,0xBBB,0x888,0x666,0x000,0x666,0x444,0x222,0xAAA};
uint pal_white[16]={0x888,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF,0xFFF};


uint pal_sega11[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0x000,0x400,0x800,0xc00,0xf44,0xf88,0xfcc};
uint pal_sega112[16]={0xfcf,0xfff,0xD10,0xF99,0xFee,0x374,0x697,0xddd,0x000,0x000,0x400,0x800,0xc00,0xf44,0xf88,0xfcc};


uint pal_sega12[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0xfcc,0x000,0x400,0x800,0xc00,0xf44,0xf88};
uint pal_sega13[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0xf88,0xfcc,0x000,0x400,0x800,0xc00,0xf44};
uint pal_sega14[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0xf44,0xf88,0xfcc,0x000,0x400,0x800,0xc00};
uint pal_sega15[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0xc00,0xf44,0xf88,0xfcc,0x000,0x400,0x800};
uint pal_sega16[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0x800,0xc00,0xf44,0xf88,0xfcc,0x000,0x400};
uint pal_sega17[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0x400,0x800,0xc00,0xf44,0xf88,0xfcc,0x000};
uint pal_sega18[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0x000,0x400,0x800,0xc00,0xf44,0xf88,0xfcc};
uint pal_sega19[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0x000,0x400,0x800,0xc00,0xf44,0xf88,0xfcc};


/*bgpal2*/
uint pal_sega2[16]={0xfcf,0xfff,0x01d,0x99f,0xeef,0x473,0x796,0xddd,0x000,0x000,0x400,0x800,0xc00,0xf44,0xf88,0xfcc};
/*sonic pal 1*/
uint pal_sprites[16]={0xfcf,0xfff,0x46a,0x08e,0x0ae,0x008,0x00e,0xeee,0xecc,0xcaa,0x866,0x222,0xe66,0xc42,0x822,0x8ae};
/*sonic pal 2*/
uint pal_sprites2[16]={0xfcf,0xfff,0xa64,0xe80,0xea0,0x800,0xe00,0xeee,0xCce,0xaac,0x668,0x222,0x66e,0x24c,0x228,0xea8};

char message_0[]="VRAM TILES            ";

char message_1[]="FVR TECHNICAL DEMO !!!!            ";
char message_2[]="REGISTRES VDP                               ";
char message_22[]="320*224                                ";
char message_23[]="256*224                                ";
char message_24[]="256*240                                ";
char message_25[]="320*240                                ";
char message_26[]="320*224                                ";
char message_3[]="PALETTES                                  ";
char message_4[]="TILES                                        ";
char message_5[]="SCROLLS                                   ";
char message_52[]="Horizontal plane*plane                 ";
char message_53[]="Horizontal tile*tile                 ";
char message_54[]="Horizontal pixel*pixel                 ";
char message_55[]="Vertical plane*plane                 ";
char message_56[]="Vertical 2tiles*2tiles                 ";
char message_57[]="Vertical & Horizontal                 ";
char message_6[]="SPRITES                                    ";
char message_7[]="SEGA C'EST PLUS FORT QUE TOI                                    ";

void   init_gfx1();
void   init_gfx2();
void   init_gfx3();
void   init_gfx4();
void   init_gfx5();

void   init_gfx6();
void   init_gfx7();
/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction principale.
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

void main()
  {
    int i,scrollxa=0,scrollya=0,scrollyz=0,scrollyt=0,scrollxb=0,scrollyb=0,wait=0,k=0;
    uint *pw,z=0;
    ulong *pl;
    pl = (ulong *) GFXCNTL;


    init_gfx1();
    fvr_set_pal(0,pal_gray);
    fvr_set_pal(1,pal_gray);
    fvr_set_pal(2,pal_gray);
    fvr_set_pal(3,pal_gray);

    fvr_load_tiles(1,336,0,bg_md);
    fvr_load_tiles(336,432,0,chor);
    fvr_load_tiles(432,448,0,pal);
    fvr_load_tiles(448,496,0,sega);
    fvr_load_tiles(496,600,0,sprites);

    fvr_clone_tile_64(1, 2048, 0,64, 0xE000, 0x0000);/*B*/
    fvr_clone_tile_64(0, 2048, 0,64, 0xC000, 0x8000);  /*A*/
    /*STEP1 PPE CHUCHU ROCKET*/
    fvr_show_tiles_64(1, 600, 1, 40, 0xE000, 0x0000);

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_clone_tile_64(1, 2048, 0,64, 0xE000, 0x0000);/*B*/

      for(i=0;i<30;i++) 
        {
          fvr_show_tiles_64(336-32+message_1[i], 336-31+message_1[i], 0, 40, 0xC080+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
      for(i=0;i<10;i++)/*REGISTERSSSSSSSSSSSSSSSS*/
        {
          fvr_show_tiles_64(336-32+message_2[i], 336-31+message_2[i], 0, 40, 0xC104+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
      for(i=0;i<10;i++)
        {
          fvr_show_tiles_64(336-32+message_22[i], 336-31+message_22[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    init_gfx2();/*256*224*/
      for(i=0;i<10;i++)
        {
          fvr_show_tiles_64(336-32+message_23[i], 336-31+message_23[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    init_gfx3();/*256*240*/
      for(i=0;i<10;i++)
        {
          fvr_show_tiles_64(336-32+message_24[i], 336-31+message_24[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    init_gfx4();/*320*240*/
      for(i=0;i<10;i++)
        {
          fvr_show_tiles_64(336-32+message_25[i], 336-31+message_25[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}


    init_gfx5();/*320*224*/
      for(i=0;i<10;i++)
        {
          fvr_show_tiles_64(336-32+message_22[i], 336-31+message_22[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}


    fvr_clone_tile_64(1, 2048, 0,64, 0xE000, 0x0000);/*B*/
    fvr_clone_tile_64(0, 2048, 0,64, 0xC000, 0x8000);  /*A*/
      for(i=0;i<30;i++) 
        {
          fvr_show_tiles_64(336-32+message_1[i], 336-31+message_1[i], 0, 40, 0xC080+2*i, 0x8000);
        }
      for(i=0;i<10;i++)/*PAL*/
        {
          fvr_show_tiles_64(336-32+message_3[i], 336-31+message_3[i], 0, 40, 0xC104+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

     fvr_show_tiles_64(432, 448, 0, 40, 0xCC02, 0x8000);
     fvr_show_tiles_64(432, 448, 1, 40, 0xCD02, 0x8000);
     fvr_show_tiles_64(432, 448, 2, 40, 0xCC2E, 0x8000);
     fvr_show_tiles_64(432, 448, 3, 40, 0xCD2E, 0x8000);

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_set_pal(0,pal_sega11);
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_set_pal(1,pal_sega2);
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_set_pal(2,pal_sprites);
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_set_pal(3,pal_sprites2);

    /*Next*/
   fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

      for(i=0;i<10;i++)/*TILES*/
        {
          fvr_show_tiles_64(336-32+message_4[i], 336-31+message_4[i], 0, 40, 0xC104+2*i, 0x8800);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
      for(i=0;i<10;i++)/*TILES*/
        {
          fvr_show_tiles_64(336-32+message_4[i], 336-31+message_4[i], 0, 40, 0xC104+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
      for(i=0;i<335;i++)/*TILES*/
        {
          fvr_show_tiles_64(1, 2+i, 1, 28, 0xE212, 0x0000);
          fvr_wait_sync();
        }

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_set_pal(1,pal_sega112);
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_set_pal(1,pal_sega11);
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_show_tiles_64(448, 496, 0, 12, 0xC904, 0x8000);
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();


    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_show_tiles_64(448, 496, 0, 12, 0xC934, 0x0000);
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();


    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}


       for(i=0;i<5;i++)
         {
            fvr_set_pal(0,pal_sega12);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega13);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega14);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega15);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega16);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega17);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega18);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega19);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
            fvr_set_pal(0,pal_sega11);
            fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
         }

      for(i=0;i<10;i++)/*Scroles*/
        {
          fvr_show_tiles_64(336-32+message_5[i], 336-31+message_5[i], 0, 40, 0xC104+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {
          if(fvr_joypad_result[1]==JOY_LEFT)
            {scrollxa--;}
          if(fvr_joypad_result[1]==JOY_RIGHT)
            {scrollxa++;}
          if(fvr_joypad_result[1]==JOY_UP)
            {scrollya++;}
          if(fvr_joypad_result[1]==JOY_DOWN)
            {scrollya--;}

          if(fvr_joypad_result[1]==JOY_LEFT+BUTTON_B)
            {scrollxb--;}
          if(fvr_joypad_result[1]==JOY_RIGHT+BUTTON_B)
            {scrollxb++;}
          if(fvr_joypad_result[1]==JOY_UP+BUTTON_B)
            {scrollyb++;}
          if(fvr_joypad_result[1]==JOY_DOWN+BUTTON_B)
            {scrollyb--;}

          fvr_scroll_horz(scrollxa,scrollxb);
          fvr_scroll_vert(scrollya,scrollyb);
          fvr_wait_sync();
          fvr_joypad_read();
        }

    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_scroll_horz(0,0);
    fvr_scroll_vert(0,0);

      for(i=0;i<28;i++)
        {
          fvr_show_tiles_64(336-32+message_52[i], 336-31+message_52[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

      for(i=0;i<512;i++)
        {
          fvr_scroll_horz(0,i);
          fvr_wait_sync();
        }
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

      for(i=0;i<28;i++)
        {
          fvr_show_tiles_64(336-32+message_53[i], 336-31+message_53[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

      init_gfx6();/*scroll horz cell/cells*/

      for(i=0;i<512;i++)
        {
          fvr_scroll_horz2(0,i);
          fvr_wait_sync();
        }

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

      for(i=0;i<28;i++)
        {
          fvr_show_tiles_64(336-32+message_54[i], 336-31+message_54[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

      init_gfx7();/*scroll horz cell/cells*/

      for(i=0;i<512;i++)
        {
          fvr_scroll_horz2(0,i);
          fvr_wait_sync();
        }
       
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}
   fvr_scroll_horz(0,0);
      for(i=0;i<28;i++)
        {
          fvr_show_tiles_64(336-32+message_55[i], 336-31+message_55[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

      for(i=0;i<256;i++)
        {
          fvr_scroll_vert(0,i);
          fvr_wait_sync();
        }

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

      for(i=0;i<28;i++)
        {
          fvr_show_tiles_64(336-32+message_56[i], 336-31+message_56[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

      for(i=0;i<256;i++)
        {
          fvr_scroll_vert2(0,i);
          fvr_wait_sync();
        }

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

      for(i=0;i<28;i++)
        {
          fvr_show_tiles_64(336-32+message_57[i], 336-31+message_57[i], 0, 40, 0xC204+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

      for(i=0;i<512;i++)
        {
          fvr_scroll_vert(0,i);
          fvr_scroll_horz2(0,-i);
          fvr_wait_sync();
        }

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}

    fvr_scroll_horz(0,0);
    fvr_scroll_vert(0,0);


    fvr_clone_tile_64(0, 600, 0,64, 0xC100, 0x8000);  /*A*/
      for(i=0;i<10;i++)/*SPRITES*/
        {
          fvr_show_tiles_64(336-32+message_6[i], 336-31+message_6[i], 0, 40, 0xC104+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }



    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
 
      for(i=0;i<16;i++)
        {

          *pl = GFX_WRITE_ADDR(0xD400);/*goto base directly*/
          pw = (uint *) GFXDATA;
          *pw=230; /*y*/
          *pw=0x1+0x100*i; /*come from cursor*/
          *pw=0x8160+17;
          *pw=150; /*x*/
          fvr_joypad_read();
            while(fvr_joypad_result[1]!=BUTTON_S)
              {fvr_wait_sync();fvr_joypad_read();}
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {fvr_wait_sync();fvr_joypad_read();}
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    scrollxa=0;scrollya=0;i=0;scrollxb=0;scrollyb=0;
    fvr_joypad_result[1]=BUTTON_B;
      while(fvr_joypad_result[1]!=BUTTON_S)
        {
          if(fvr_joypad_result[1]==JOY_LEFT)
            {scrollxa--;}
          if(fvr_joypad_result[1]==JOY_RIGHT)
            {scrollxa++;}
          if(fvr_joypad_result[1]==JOY_UP)
            {scrollya--;}
          if(fvr_joypad_result[1]==JOY_DOWN)
            {scrollya++;}
          if(fvr_joypad_result[1]==BUTTON_A)
            {i=1;}
          if(fvr_joypad_result[1]==BUTTON_C)
            {i=0;}

          if(fvr_joypad_result[1]==JOY_LEFT+BUTTON_B)
            {scrollxb--;}
          if(fvr_joypad_result[1]==JOY_RIGHT+BUTTON_B)
            {scrollxb++;}
          if(fvr_joypad_result[1]==JOY_UP+BUTTON_B)
            {scrollyb--;}
          if(fvr_joypad_result[1]==JOY_DOWN+BUTTON_B)
            {scrollyb++;}

          *pl = GFX_WRITE_ADDR(0xD400);/*goto base directly*/
          pw = (uint *) GFXDATA;
          *pw=230+scrollya; /*y*/
          *pw=0xF01; /*come from cursor*/
          *pw=0xC1F4-0x8000*i+k;
          *pw=150+scrollxa; /*x*/

          *pw=230+32+scrollyb+scrollya; /*y*/
          *pw=0xc02; /*come from cursor*/
          *pw=0xC254-0x8000*i;
          *pw=150+scrollxb+scrollxa; /*x*/

          fvr_wait_sync();
          fvr_joypad_read();
        }
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();

    scrollyb=0;scrollxa=1;scrollya=0;i=0;
    fvr_joypad_read();
      while(fvr_joypad_result[1]!=BUTTON_S)
        {

          if(fvr_joypad_result[1]==BUTTON_C+JOY_UP)
            {k=0x000;}
          if(fvr_joypad_result[1]==BUTTON_C+JOY_DOWN)
            {k=0x800;}
          if(fvr_joypad_result[1]==BUTTON_C+JOY_LEFT)
            {k=0x1000;}
          if(fvr_joypad_result[1]==BUTTON_C+JOY_RIGHT)
            {k=0x1800;}
          if(fvr_joypad_result[1]==BUTTON_A)
            {z=0x6000;}
          if(fvr_joypad_result[1]==BUTTON_B)
            {z=0x0;}
           if(scrollxa<220){scrollxa++;}
          i++;
          if(i>10)
            {i=0;
              scrollyb++;if(scrollyb>1){scrollyb=0;}
              scrollya++;if(scrollya>3){scrollya=0;}
            }
          *pl = GFX_WRITE_ADDR(0xD400);/*goto base directly*/
          pw = (uint *) GFXDATA;
          *pw=230; /*y*/
          *pw=0xF01; /*come from cursor*/
          *pw=0xC1F4+scrollyb*16;
          *pw=150; /*x*/

          *pw=230+32; /*y*/
          *pw=0xc02; /*come from cursor*/
          *pw=0xC254;
          *pw=150; /*x*/

          *pw=10+scrollxa; /*y*/
          *pw=0xF03; /*come from cursor*/
          *pw=0xC1F4+32+scrollya*16+k+z;
          *pw=190; /*x*/

          fvr_wait_sync();
          fvr_joypad_read();
        }

      for(i=0;i<30;i++)/*SPRITES*/
        {
          fvr_show_tiles_64(336-32+message_7[i], 336-31+message_7[i], 0, 40, 0xC104+2*i, 0x8000);
          fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
        }

    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
    fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();fvr_wait_sync();
      while(1)
        {
          *pl = GFX_WRITE_ADDR(0xD400);/*goto base directly*/
          pw = (uint *) GFXDATA;
          if(z>10)
            {z=0;
              scrollya++;if(scrollya>3){scrollya=0;}
            }scrollxa++;scrollyz++;scrollyz++;scrollyt++;scrollyt++;scrollyt++;
          for(i=0;i<79;i++)
            {
              
              *pw=128+32*i+scrollxa; /*y*/
              *pw=0xF00+i+1; /*come from cursor*/
              
              if(i>30 && i<50){*pw=0xC1F4+32+scrollya*16;*pw=128+4*i+scrollyt; /*x*/}
              else if(i<30){*pw=0xC1F4+32+scrollya*16;*pw=128+4*i-scrollyz; /*x*/}
              else{*pw=0xC1F4+32+scrollya*16-0x8000;*pw=128+4*i+scrollxa; /*x*/}
            }
           fvr_scroll_horz2(scrollyb,-scrollyb);
           fvr_scroll_vert(scrollyb,-scrollyb);
z++;scrollyb++;


          fvr_wait_sync();
        }



  }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "Init_gfx".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/
void init_gfx1()
  {
    register uchar *pb,i;
    register uint *pw;

    register ulong *pl;
    pl = (ulong *) GFXCNTL;

    /*Set the vdp (Visual Display Processor) 
    Hhh, 'est la config parfaite!!!! (1680 tiles de dram)	Segaaaaa, c'est plus fort que toi!!!	
    Infos:
    - 0-1000>4ko (une plane 64*32 utilise 4ko de VRAM)
    - 0-400  >1ko (Hscroll utilise 1ko de VRAM avec une rez de h320)	
    - 0-400  >1ko (Sprite utilise 1ko de VRAM avec une rez de h320)				
    Rcapitulatif:
    - 0-C000	Ram	(tile0>tile1540)
    - C000-D000	Plane A	(compatible with 111 000!!!)
    - D000-D400	Hscoll
    - D400-E000	Sprites
    - E000-F000	Plane B	(compatible with 000 111!!!)								
    - F000-FFFF	Ram	(tile1920>tile2042)						*/
    pw = (uint *) GFXCNTL;
    *pw = 0x8016;   /* reg. 00 - Enable HBL						*/
    *pw = 0x8174;   /* reg. 01 - Enable VBL 						*/
    *pw = 0x8230;   /* reg. 02 - PlnA	$30*$400=$C000		ok	C000 - D000	*/
    *pw = 0x8340;   /* reg. 03 - Win	$40*$400=$10000		offset	FFFFF - XXX	*/
    *pw = 0x8407;   /* reg. 04 - PlnB	$7*$2000=$E000		ok	E000 - F000	*/
    *pw = 0x856A;   /* reg. 05 - Sprt	$6A*$200=$D400		ok	D400 - E000 	*/
    *pw = 0x8600;   /* reg. 06 							*/
    *pw = 0x8700;   /* reg. 07 - BGc							*/
    *pw = 0x8801;   /* reg. 08 							*/
    *pw = 0x8901;   /* reg. 09 							*/
    *pw = 0x8a01;   /* reg. 10 							*/
    *pw = 0x8b07;   /* reg. 11 - Full 2cells-vscroll and 1pixel h-scroll	 precision			*/
    *pw = 0x8c89;   /* reg. 12 - Screen width set to 320 					*/
    *pw = 0x8d34;   /* reg. 13 - Hscrlt	$34*400=$D000		ok	D000 - D400	*/
    *pw = 0x8E00;   /* reg. 14 							*/
    *pw = 0x8f02;    /* reg. 15 							*/
    *pw = 0x9001;   /* reg. 16 - Planes set to 512*256					*/
    *pw = 0x9100;   /* reg. 17 							*/
    *pw = 0x9200;   /* reg. 18 							*/
    *pw = 0x9300;   /* reg. 19 							*/
    *pw = 0x9400;   /* reg. 20 							*/
    *pw = 0x9500;   /* reg. 21 							*/
    *pw = 0x9600;   /* reg. 22 							*/

    /*Init joypads*/
    pb = (uchar *) 0xa10009;
    *pb = 0x40;
    pb += 2;
    *pb = 0x40;
    pb += 2;
    *pb = 0x40;


    /*Todo: check if 50hz or 60hz*/

    fvr_scroll_horz(0,0);
    fvr_scroll_vert(0,0);


  }
void init_gfx2()/*256*224*/
  {
    register uchar *pb,i;
    register uint *pw;
    register ulong *pl;
    pl = (ulong *) GFXCNTL;

    pw = (uint *) GFXCNTL;
    *pw = 0x8016;   /* reg. 00 - Enable HBL						*/
    *pw = 0x8174;   /* reg. 01 - Enable VBL 						*/
    *pw = 0x8230;   /* reg. 02 - PlnA	$30*$400=$C000		ok	C000 - D000	*/
    *pw = 0x8340;   /* reg. 03 - Win	$40*$400=$10000		offset	FFFFF - XXX	*/
    *pw = 0x8407;   /* reg. 04 - PlnB	$7*$2000=$E000		ok	E000 - F000	*/
    *pw = 0x856A;   /* reg. 05 - Sprt	$6A*$200=$D400		ok	D400 - E000 	*/
    *pw = 0x8600;   /* reg. 06 							*/
    *pw = 0x8700;   /* reg. 07 - BGc							*/
    *pw = 0x8801;   /* reg. 08 							*/
    *pw = 0x8901;   /* reg. 09 							*/
    *pw = 0x8a01;   /* reg. 10 							*/
    *pw = 0x8b07;   /* reg. 11 - Full 2cells-vscroll and 1pixel h-scroll	 precision			*/
    *pw = 0x8c08;   /* reg. 12 - Screen width set to 320 					*/
    *pw = 0x8d34;   /* reg. 13 - Hscrlt	$34*400=$D000		ok	D000 - D400	*/
    *pw = 0x8E00;   /* reg. 14 							*/
    *pw = 0x8f02;    /* reg. 15 							*/
    *pw = 0x9001;   /* reg. 16 - Planes set to 512*256					*/
    *pw = 0x9100;   /* reg. 17 							*/
    *pw = 0x9200;   /* reg. 18 							*/
    *pw = 0x9300;   /* reg. 19 							*/
    *pw = 0x9400;   /* reg. 20 							*/
    *pw = 0x9500;   /* reg. 21 							*/
    *pw = 0x9600;   /* reg. 22 							*/
  }

void init_gfx3()/*256*240*/
  {
    register uchar *pb,i;
    register uint *pw;
    register ulong *pl;
    pl = (ulong *) GFXCNTL;

    pw = (uint *) GFXCNTL;
    *pw = 0x8016;   /* reg. 00 - Enable HBL						*/
    *pw = 0x816C;   /* reg. 01 - Enable VBL 						*/
    *pw = 0x8230;   /* reg. 02 - PlnA	$30*$400=$C000		ok	C000 - D000	*/
    *pw = 0x8340;   /* reg. 03 - Win	$40*$400=$10000		offset	FFFFF - XXX	*/
    *pw = 0x8407;   /* reg. 04 - PlnB	$7*$2000=$E000		ok	E000 - F000	*/
    *pw = 0x856A;   /* reg. 05 - Sprt	$6A*$200=$D400		ok	D400 - E000 	*/
    *pw = 0x8600;   /* reg. 06 							*/
    *pw = 0x8700;   /* reg. 07 - BGc							*/
    *pw = 0x8801;   /* reg. 08 							*/
    *pw = 0x8901;   /* reg. 09 							*/
    *pw = 0x8a01;   /* reg. 10 							*/
    *pw = 0x8b07;   /* reg. 11 - Full 2cells-vscroll and 1pixel h-scroll	 precision			*/
    *pw = 0x8c08;   /* reg. 12 - Screen width set to 320 					*/
    *pw = 0x8d34;   /* reg. 13 - Hscrlt	$34*400=$D000		ok	D000 - D400	*/
    *pw = 0x8E00;   /* reg. 14 							*/
    *pw = 0x8f02;    /* reg. 15 							*/
    *pw = 0x9001;   /* reg. 16 - Planes set to 512*256					*/
    *pw = 0x9100;   /* reg. 17 							*/
    *pw = 0x9200;   /* reg. 18 							*/
    *pw = 0x9300;   /* reg. 19 							*/
    *pw = 0x9400;   /* reg. 20 							*/
    *pw = 0x9500;   /* reg. 21 							*/
    *pw = 0x9600;   /* reg. 22 							*/
  }
void init_gfx4() /*320*240*/
  {
    register uchar *pb,i;
    register uint *pw;
    register ulong *pl;
    pl = (ulong *) GFXCNTL;

    pw = (uint *) GFXCNTL;
    *pw = 0x8016;   /* reg. 00 - Enable HBL						*/
    *pw = 0x816C;   /* reg. 01 - Enable VBL 						*/
    *pw = 0x8230;   /* reg. 02 - PlnA	$30*$400=$C000		ok	C000 - D000	*/
    *pw = 0x8340;   /* reg. 03 - Win	$40*$400=$10000		offset	FFFFF - XXX	*/
    *pw = 0x8407;   /* reg. 04 - PlnB	$7*$2000=$E000		ok	E000 - F000	*/
    *pw = 0x856A;   /* reg. 05 - Sprt	$6A*$200=$D400		ok	D400 - E000 	*/
    *pw = 0x8600;   /* reg. 06 							*/
    *pw = 0x8700;   /* reg. 07 - BGc							*/
    *pw = 0x8801;   /* reg. 08 							*/
    *pw = 0x8901;   /* reg. 09 							*/
    *pw = 0x8a01;   /* reg. 10 							*/
    *pw = 0x8b07;   /* reg. 11 - Full 2cells-vscroll and 1pixel h-scroll	 precision			*/
    *pw = 0x8c89;   /* reg. 12 - Screen width set to 320 					*/
    *pw = 0x8d34;   /* reg. 13 - Hscrlt	$34*400=$D000		ok	D000 - D400	*/
    *pw = 0x8E00;   /* reg. 14 							*/
    *pw = 0x8f02;    /* reg. 15 							*/
    *pw = 0x9001;   /* reg. 16 - Planes set to 512*256					*/
    *pw = 0x9100;   /* reg. 17 							*/
    *pw = 0x9200;   /* reg. 18 							*/
    *pw = 0x9300;   /* reg. 19 							*/
    *pw = 0x9400;   /* reg. 20 							*/
    *pw = 0x9500;   /* reg. 21 							*/
    *pw = 0x9600;   /* reg. 22 							*/
  }
void init_gfx5()
  {
    register uchar *pb,i;
    register uint *pw;

    register ulong *pl;
    pl = (ulong *) GFXCNTL;

    /*Set the vdp (Visual Display Processor) 
    Hhh, 'est la config parfaite!!!! (1680 tiles de dram)	Segaaaaa, c'est plus fort que toi!!!	
    Infos:
    - 0-1000>4ko (une plane 64*32 utilise 4ko de VRAM)
    - 0-400  >1ko (Hscroll utilise 1ko de VRAM avec une rez de h320)	
    - 0-400  >1ko (Sprite utilise 1ko de VRAM avec une rez de h320)				
    Rcapitulatif:
    - 0-C000	Ram	(tile0>tile1540)
    - C000-D000	Plane A	(compatible with 111 000!!!)
    - D000-D400	Hscoll
    - D400-E000	Sprites
    - E000-F000	Plane B	(compatible with 000 111!!!)								
    - F000-FFFF	Ram	(tile1920>tile2042)						*/
    pw = (uint *) GFXCNTL;
    *pw = 0x8016;   /* reg. 00 - Enable HBL						*/
    *pw = 0x8174;   /* reg. 01 - Enable VBL 						*/
    *pw = 0x8230;   /* reg. 02 - PlnA	$30*$400=$C000		ok	C000 - D000	*/
    *pw = 0x8340;   /* reg. 03 - Win	$40*$400=$10000		offset	FFFFF - XXX	*/
    *pw = 0x8407;   /* reg. 04 - PlnB	$7*$2000=$E000		ok	E000 - F000	*/
    *pw = 0x856A;   /* reg. 05 - Sprt	$6A*$200=$D400		ok	D400 - E000 	*/
    *pw = 0x8600;   /* reg. 06 							*/
    *pw = 0x8700;   /* reg. 07 - BGc							*/
    *pw = 0x8801;   /* reg. 08 							*/
    *pw = 0x8901;   /* reg. 09 							*/
    *pw = 0x8a01;   /* reg. 10 							*/
    *pw = 0x8b07;   /* reg. 11 - Full 2cells-vscroll and 1pixel h-scroll	 precision			*/
    *pw = 0x8c89;   /* reg. 12 - Screen width set to 320 					*/
    *pw = 0x8d34;   /* reg. 13 - Hscrlt	$34*400=$D000		ok	D000 - D400	*/
    *pw = 0x8E00;   /* reg. 14 							*/
    *pw = 0x8f02;    /* reg. 15 							*/
    *pw = 0x9001;   /* reg. 16 - Planes set to 512*256					*/
    *pw = 0x9100;   /* reg. 17 							*/
    *pw = 0x9200;   /* reg. 18 							*/
    *pw = 0x9300;   /* reg. 19 							*/
    *pw = 0x9400;   /* reg. 20 							*/
    *pw = 0x9500;   /* reg. 21 							*/
    *pw = 0x9600;   /* reg. 22 							*/
  }

void init_gfx6()/*scroll horz cell/cells*/
  {
    register uchar *pb,i;
    register uint *pw;

    register ulong *pl;
    pl = (ulong *) GFXCNTL;

    /*Set the vdp (Visual Display Processor) 
    Hhh, 'est la config parfaite!!!! (1680 tiles de dram)	Segaaaaa, c'est plus fort que toi!!!	
    Infos:
    - 0-1000>4ko (une plane 64*32 utilise 4ko de VRAM)
    - 0-400  >1ko (Hscroll utilise 1ko de VRAM avec une rez de h320)	
    - 0-400  >1ko (Sprite utilise 1ko de VRAM avec une rez de h320)				
    Rcapitulatif:
    - 0-C000	Ram	(tile0>tile1540)
    - C000-D000	Plane A	(compatible with 111 000!!!)
    - D000-D400	Hscoll
    - D400-E000	Sprites
    - E000-F000	Plane B	(compatible with 000 111!!!)								
    - F000-FFFF	Ram	(tile1920>tile2042)						*/
    pw = (uint *) GFXCNTL;
    *pw = 0x8016;   /* reg. 00 - Enable HBL						*/
    *pw = 0x8174;   /* reg. 01 - Enable VBL 						*/
    *pw = 0x8230;   /* reg. 02 - PlnA	$30*$400=$C000		ok	C000 - D000	*/
    *pw = 0x8340;   /* reg. 03 - Win	$40*$400=$10000		offset	FFFFF - XXX	*/
    *pw = 0x8407;   /* reg. 04 - PlnB	$7*$2000=$E000		ok	E000 - F000	*/
    *pw = 0x856A;   /* reg. 05 - Sprt	$6A*$200=$D400		ok	D400 - E000 	*/
    *pw = 0x8600;   /* reg. 06 							*/
    *pw = 0x8700;   /* reg. 07 - BGc							*/
    *pw = 0x8801;   /* reg. 08 							*/
    *pw = 0x8901;   /* reg. 09 							*/
    *pw = 0x8a01;   /* reg. 10 							*/
    *pw = 0x8b02;   /* reg. 11 - Full 2cells-vscroll and 1pixel h-scroll	 precision			*/
    *pw = 0x8c89;   /* reg. 12 - Screen width set to 320 					*/
    *pw = 0x8d34;   /* reg. 13 - Hscrlt	$34*400=$D000		ok	D000 - D400	*/
    *pw = 0x8E00;   /* reg. 14 							*/
    *pw = 0x8f02;    /* reg. 15 							*/
    *pw = 0x9001;   /* reg. 16 - Planes set to 512*256					*/
    *pw = 0x9100;   /* reg. 17 							*/
    *pw = 0x9200;   /* reg. 18 							*/
    *pw = 0x9300;   /* reg. 19 							*/
    *pw = 0x9400;   /* reg. 20 							*/
    *pw = 0x9500;   /* reg. 21 							*/
    *pw = 0x9600;   /* reg. 22 							*/
  }

void init_gfx7()/*scroll horz line/line*/
  {
    register uchar *pb,i;
    register uint *pw;

    register ulong *pl;
    pl = (ulong *) GFXCNTL;

    /*Set the vdp (Visual Display Processor) 
    Hhh, 'est la config parfaite!!!! (1680 tiles de dram)	Segaaaaa, c'est plus fort que toi!!!	
    Infos:
    - 0-1000>4ko (une plane 64*32 utilise 4ko de VRAM)
    - 0-400  >1ko (Hscroll utilise 1ko de VRAM avec une rez de h320)	
    - 0-400  >1ko (Sprite utilise 1ko de VRAM avec une rez de h320)				
    Rcapitulatif:
    - 0-C000	Ram	(tile0>tile1540)
    - C000-D000	Plane A	(compatible with 111 000!!!)
    - D000-D400	Hscoll
    - D400-E000	Sprites
    - E000-F000	Plane B	(compatible with 000 111!!!)								
    - F000-FFFF	Ram	(tile1920>tile2042)						*/
    pw = (uint *) GFXCNTL;
    *pw = 0x8016;   /* reg. 00 - Enable HBL						*/
    *pw = 0x8174;   /* reg. 01 - Enable VBL 						*/
    *pw = 0x8230;   /* reg. 02 - PlnA	$30*$400=$C000		ok	C000 - D000	*/
    *pw = 0x8340;   /* reg. 03 - Win	$40*$400=$10000		offset	FFFFF - XXX	*/
    *pw = 0x8407;   /* reg. 04 - PlnB	$7*$2000=$E000		ok	E000 - F000	*/
    *pw = 0x856A;   /* reg. 05 - Sprt	$6A*$200=$D400		ok	D400 - E000 	*/
    *pw = 0x8600;   /* reg. 06 							*/
    *pw = 0x8700;   /* reg. 07 - BGc							*/
    *pw = 0x8801;   /* reg. 08 							*/
    *pw = 0x8901;   /* reg. 09 							*/
    *pw = 0x8a01;   /* reg. 10 							*/
    *pw = 0x8b07;   /* reg. 11 - Full 2cells-vscroll and 1pixel h-scroll	 precision			*/
    *pw = 0x8c89;   /* reg. 12 - Screen width set to 320 					*/
    *pw = 0x8d34;   /* reg. 13 - Hscrlt	$34*400=$D000		ok	D000 - D400	*/
    *pw = 0x8E00;   /* reg. 14 							*/
    *pw = 0x8f02;    /* reg. 15 							*/
    *pw = 0x9001;   /* reg. 16 - Planes set to 512*256					*/
    *pw = 0x9100;   /* reg. 17 							*/
    *pw = 0x9200;   /* reg. 18 							*/
    *pw = 0x9300;   /* reg. 19 							*/
    *pw = 0x9400;   /* reg. 20 							*/
    *pw = 0x9500;   /* reg. 21 							*/
    *pw = 0x9600;   /* reg. 22 							*/
  }